% ================== Programma armonica_1.m =================== %
%                                                               %
%              ESERCITAZIONE di ANALISI NUMERICA                %
% 								                                %
%    Programma per l'analisi della composizione di armoniche    % 
%    e della relativa rappresentazione come vettori rotanti     %
%            (ciascuno con la propria pulsazione)               %
% ============================================================= %

clear
close all

% ----------------------------------------------------------

% Definizione dei dati

i=0:1:720;

c0=input('Ampiezza del primo fasore (0-3) = ');
ang0=input('Angolo () del primo fasore con asse x = ');
ang0 = ang0*pi/180;
a0=c0*cos(ang0);
b0=c0*sin(ang0);
alfa0=ang0;


c1=input('Ampiezza del secondo fasore (0-2) = ');
ang1=input('Angolo () del secondo fasore con asse x = ');
ang1=ang1*pi/180;
a1=c1*cos(ang1);
b1=c1*sin(ang1);
alfa1=ang1;



% a0=input('Ampiezza fasore a0 asse x (0-3) = ');
% b0=input('Ampiezza fasore b0 asse y (0-2) = ');
% c0=sqrt(a0^2+b0^2);
% alfa0=atan2(b0,a0);
% 
% a1=input('Ampiezza fasore a1 asse x (0-3) = ');
% b1=input('Ampiezza fasore b1 asse y (0-2) = ');
% c1 = sqrt(a1^2+b1^2);
% alfa1 = atan2(b1,a1);

ord = input('Ordine della seconda componente armonica = ')

% ------------------------------------------------------

% Calcolo delle componenti dei fasori

ax = zeros(size(i));
ay = zeros(size(i));
bx = zeros(size(i));
by = zeros(size(i));
cx = zeros(size(i));
cy = zeros(size(i));

ax1 = zeros(size(i));
ay1 = zeros(size(i));
bx1 = zeros(size(i));
by1 = zeros(size(i));
cx1 = zeros(size(i));
cy1 = zeros(size(i));

axt = zeros(size(i));
ayt = zeros(size(i));
bxt = zeros(size(i));
byt = zeros(size(i));
cxt = zeros(size(i));
cyt = zeros(size(i));

anga = i*pi/180;
angb = (i+90)*pi/180;
angc = anga+alfa0;

anga1 = i*ord*pi/180;
angb1 = (i*ord+90)*pi/180;
angc1 = anga1+alfa1;

ax = a0*cos(anga);
ay = a0*sin(anga);
bx = b0*cos(angb);
by = b0*sin(angb);
cx = c0*cos(angc);
cy = c0*sin(angc);

ax1 = a1*cos(anga1);
ay1 = a1*sin(anga1);
bx1 = b1*cos(angb1);
by1 = b1*sin(angb1);
cx1 = c1*cos(angc1);
cy1 = c1*sin(angc1);

cxt = cx+ax1+bx1;
cyt = cy+ay1+by1;

% --------------------------------------------------------------

% Disegno degli assi e dei fasori iniziali per una sola armonica

figure(1)

plot([0 1.1*c0],[0 0],'k')
axis([-5.7152 5.7152 -5.4083 3.6056])
title('FASORI dell''armonica di ordine 1')
hold on
plot([0 0],[0 1.1*c0],'k')

plot([0 ax(1)],[0 ay(1)],'r',ax(1),ay(1),'or')
plot([0 bx(1)],[0 by(1)],'r',bx(1),by(1),'or')
plot([0 cx(1)],[0 cy(1)],'b',cx(1),cy(1),'ob','LineWidth',3)
plot(0,0,'bo')
plot([0 cx(1)],[-1.25*c0 -1.25*c0],'b',cx(1),-1.25*c0,'diamondb')
plot([cx(1) cx(1)],[-1.25*c0 cy(1)],':b')
plot([0 0],[-1.25*c0 0],':b',0,-1.25*c0,'ob')
hold off

ind=input('Se vuoi il diagramma circolare dei fasori digita 1 ');

if ind == 1
   step=1;
else step=360;
end

for j=1:step:721
   plot([0 1.1*c0],[0 0],'k')
   axis([-5.7152 5.7152 -5.4083 3.6056])
   title('FASORI dell''armonica di ordine 1')
	hold on
   plot([0 0],[0 1.1*c0],'k')
   
   plot(0,0,'bo')
   plot([0 cx(1)],[-1.25*c0 -1.25*c0],'k',cx(1),-1.25*c0,'diamondk')
   plot([cx(1) cx(1)],[-1.25*c0 cy(1)],':b')
   plot([0 0],[-1.25*c0 0],':b',0,-1.25*c0,'ob')

   plot([0 ax(j)],[0 ay(j)],'r',ax(j),ay(j),'or')
   plot([0 bx(j)],[0 by(j)],'r',bx(j),by(j),'or')
   plot([0 cx(j)],[0 cy(j)],'b',cx(j),cy(j),'diamondb','LineWidth',3)
   plot(0,0,'bo')
   plot([0 cx(j)],[-1.25*c0 -1.25*c0],'b',cx(j),-1.25*c0,'diamondb')
   plot([cx(j) cx(j)],[-1.25*c0 cy(j)],':b')
   plot([0 0],[-1.25*c0 0],':b',0,-1.25*c0,'ob')
   drawnow
   hold off    
end

disp('RETURN per continuare')
pause

figure(2)

h=plot(i,cx,'b');
axis([0 360 -1.1*c0 1.1*c0])
set(h,'LineWidth',3)
grid on
xlabel('Ascissa angolare o tempo')
ylabel('Ampiezza')
title('Andamento temporale dell''armonica 1')

disp('RETURN per continuare')
pause

% -------------------------------------------------------------

% Disegno degli assi e dei fasori iniziali per una sola armonica

figure(3)

plot([0 2.2*c0],[0 0],'k')
axis([-5.7152*2 5.7152*2 -5.4083*2 3.6056*2])
title(['FASORI dell''armonica di ordine 1 e ' num2str(ord)])

hold on
plot([0 0],[0 1.1*c0],'k')

plot([0 ax(1)],[0 ay(1)],'r',ax(1),ay(1),'or')
plot([0 bx(1)],[0 by(1)],'r',bx(1),by(1),'or')
plot([0 cx(1)],[0 cy(1)],'b',cx(1),cy(1),'ob','LineWidth',3)

plot([cx(1) cx(1)+a1*cos(anga1(1))],[cy(1) cy(1)+a1*sin(anga1(1))],'r',...
   cx(1)+a1*cos(anga1(1)),cy(1)+a1*sin(anga1(1)),'or')
plot([cx(1) cx(1)+b1*cos(angb1(1))],[cy(1) cy(1)+b1*sin(angb1(1))],'r',...
   cx(1)+b1*cos(angb1(1)),cy(1)+b1*sin(angb1(1)),'or')
plot([cx(1) cxt(1)],[cy(1) cyt(1)],'b',cxt(1),cyt(1),'ob','LineWidth',3)
plot([0 cxt(1)],[0 cyt(1)],'m',cxt(1),cyt(1),'diamondm','LineWidth',3)

plot(0,0,'bo')

plot([0 cxt(1)],[-2.5*c0 -2.5*c0],'m',cxt(1),-2.5*c0,'diamondm')
plot([cxt(1) cxt(1)],[-2.5*c0 cyt(1)],':b')
plot([0 0],[-2.5*c0 0],':b',0,-2.5*c0,'ob')
hold off

ind=input('Se vuoi il diagramma circolare dei fasori digita 1 ');

if ind == 1
   step=1;
else step=360;
end

for j=1:step:721
   plot([0 2.2*c0],[0 0],'k')
	axis([-5.7152*2 5.7152*2 -5.4083*2 3.6056*2])
	title(['FASORI dell''armonica di ordine 1 e ' num2str(ord)])
	hold on
   plot([0 0],[0 1.1*c0],'k')
   
   plot(0,0,'bo')
   
   plot([0 cxt(1)],[-2.5*c0 -2.5*c0],'b',cxt(1),-2.5*c0,'diamondb')
	plot([cxt(1) cxt(1)],[-2.5*c0 cyt(1)],':b')
	plot([0 0],[-2.5*c0 0],':b',0,-2.5*c0,'ob')
	
	plot([0 ax(j)],[0 ay(j)],'r',ax(j),ay(j),'or')
	plot([0 bx(j)],[0 by(j)],'r',bx(j),by(j),'or')
	plot([0 cx(j)],[0 cy(j)],'b',cx(j),cy(j),'ob')

	plot([cx(j) cx(j)+a1*cos(anga1(j))],[cy(j) cy(j)+a1*sin(anga1(j))],'r',...
   	cx(j)+a1*cos(anga1(j)),cy(j)+a1*sin(anga1(j)),'or')
	plot([cx(j) cx(j)+b1*cos(angb1(j))],[cy(j) cy(j)+b1*sin(angb1(j))],'r',...
   	cx(j)+b1*cos(angb1(j)),cy(j)+b1*sin(angb1(j)),'or')
	plot([cx(j) cxt(j)],[cy(j) cyt(j)],'b',cxt(j),cyt(j),'ob')
	plot([0 cxt(j)],[0 cyt(j)],'m',cxt(j),cyt(j),'diamondm','LineWidth',3)

   plot(0,0,'bo')
   
   plot([0 cxt(j)],[-2.5*c0 -2.5*c0],'m',cxt(j),-2.5*c0,'diamondm')
   plot([cxt(j) cxt(j)],[-2.5*c0 cyt(j)],':b')
   plot([0 0],[-2.5*c0 0],':b',0,-2.5*c0,'ob')
   drawnow
   hold off    
end

disp('RETURN per continuare')
pause

figure(4)

h=plot(i,cxt,'m',i,cx,':b',i,cx1,':r');
axis([0 360 -2.1*c0 2.1*c0])
set(h,'LineWidth',3)
grid on
xlabel('Ascissa angolare o tempo')
ylabel('Ampiezza')
title(['Andamento temporale dell''armonica 1 e ' num2str(ord)])

    
% =============================================================== %
%							                                  	  %
%                    Termine del programma    	         		  %
%								                                  % 
% =============================================================== %