% ================ Programma fft_funz_3arm.m ================== %
%                                                               %
%              ESERCITAZIONE di ANALISI NUMERICA                %
% 								                                %
% 	            Applicazione della FFT		                  	%
% 								                                %
% ============================================================= %

clear
close all

% Definizione della base dei tempi t di campionamento (601 punti)
disp('Tempo di esame del fenomeno in s')
    tmax = 6
 
% Intervallo di campionamento
disp('Intervallo di campionamento in s')
	ts = 0.01
    
% Fequenza di campionamento in Hz
    fs = 1/ts;

% Base dei tempi
    t = 0:ts:tmax;

% Definizione dei tempi per la rappresentazione della funzione data
	tv = 0:0.002:6;

% Definizione dei parametri ampiezza [a], frequenza [f] e pulsa-
% zione [om] della forma d'onda fondamentale
	
	k1  = 5; k2 = 3; k3 = 1.5;
	f1  = 0.5; f2 = 10; f3 = 25;
	phi1 = 30; phi2 = 0; phi3 = -45;
    cost = 0.5;

% Modifica dei valori di default per i parametri

for i=1:20
	disp('============================================')
	disp('Ampiezze delle componenti   k1, k2, k3: ')
	disp([ k1 k2 k3])
	disp('Frequenze (Hz) delle componenti   f1, f2, f3: ')
	disp([f1 f2 f3])
	disp('Fasi delle componenti in gradi phi1, phi2, phi3: ')
	disp([phi1 phi2 phi3])
	disp('Costante della funzione: ')
	disp(cost)
	disp('Digita 0 ====> per non cambiare nulla') 
	disp('Digita 1 ====> per cambiare k1') 
	disp('Digita 2 ====> per cambiare k2') 
	disp('Digita 3 ====> per cambiare k3') 
	disp('Digita 4 ====> per cambiare f1') 
	disp('Digita 5 ====> per cambiare f2') 
	disp('Digita 6 ====> per cambiare f3') 
	disp('Digita 7 ====> per cambiare phi1') 
	disp('Digita 8 ====> per cambiare phi2') 
	disp('Digita 9 ====> per cambiare phi3')
    disp('Digita 10 ===> per cambiare cost')
	disp('============================================')

	m = input('Parametro per cambiare dato di default = ')
 	if m == 0; break; end
	if m == 1
		disp('---------------')
		k1
		k1 = input('Nuovo valore ampiezza k1 = ')
	end
	if m == 2
		disp('---------------')
		k2
		k2 = input('Nuovo valore ampiezza k2 = ')
	end
	if m == 3
		disp('---------------')
		k3
		k3 = input('Nuovo valore ampiezza k3 = ')
	end
	if m == 4
		disp('---------------')
		f1
		f1 = input('Nuovo valore frequenza f1 = ')
	end
	if m == 5
		disp('---------------')
		f2
		f2 = input('Nuovo valore frequenza f2 = ')
	end
	if m == 6
		disp('---------------')
		f3
		f3 = input('Nuovo valore frequenza = ')
	end
	if m == 7
		disp('---------------')
		phi1
		phi1 = input('Nuovo valore fase phi1 = ')
	end
	if m == 8
		disp('---------------')	
		phi2
		phi2 = input('Nuovo valore fase phi2 = ')
	end
	if m == 9
		disp('---------------')
		phi3
		phi3 = input('Nuovo valore fase phi3 = ')
	end
    if m == 10
		disp('---------------')
		cost
		cost = input('Nuovo valore ampiezza k2 = ')
	end
end

	k = max([k1 k2 k3]);
	om1 = f1*2*pi; om2 = f2*2*pi; om3 = f3*2*pi;
	phi1 = phi1/180*pi; phi2 = phi2/180*pi; phi3 = phi3/180*pi;
	permax = 1/min([f1 f2 f3]);
	
% Forma d'onda fondamentale e suo plottaggio
	y =k1*cos(om1*t+phi1) + k2*cos(om2*t+phi2) + k3*cos(om3*t+phi3)+cost;
	yv =k1*cos(om1*tv+phi1) + k2*cos(om2*tv+phi2) + k3*cos(om3*tv+phi3)+cost;

	figure(1)
	plot(tv,k1*cos(om1*tv+phi1),'b','LineWidth',2)
    axis([0  permax -k k])
	grid on
	xlabel('Tempo [s]')
	ylabel('Ampiezza')
	title('Componenti armoniche della funzione')
    hold on
    plot(tv,k2*cos(om2*tv+phi2),'r','LineWidth',2)
    plot(tv,k3*cos(om3*tv+phi3),'k','LineWidth',2)
    hold off
	
	pause
	
	figure(2)
	plot(tv,yv,'b','LineWidth',2)
	grid on
	xlabel('Tempo [s]')
	ylabel('Ampiezza')
	title('Funzione da campionare')

	pause

% FFT della forma d'onda con N = 512 punti di campionamento

% FFT della forma d'onda considerata

	nint  = 512;		% Numero degli intervalli di campionamento
	
	f = fs*(0:nint/2-1)/nint; 
    
    figure(3)
	
	passo = 0.25;
	
	for i = 1:24	  
		l1 = 0.25*(i-1);
		l2 = l1+passo;
		i1 = round(1+l1/ts);
		i2 = round(1+l2/ts);
        if i1 > nint
            i1 = nint;
        end
        if i2 > nint
            i2 = nint;
        end
        j1 = round(1+l1/0.002);
        j2 = round(1+l2/0.002);
        plot(tv(j1:j2),yv(j1:j2),'m','LineWidth',3)
		axis([l1 l2 min([y(i1:i2) yv(j1:j2)]) max([y(i1:i2) yv(j1:j2)]) ])
		grid on
		xlabel('Tempo [s]')
		ylabel('Ampiezza')
		title(['Funzione vera e campionata a 100 Hz nell''intervallo ',...
                num2str(tv(j1)),' - ',num2str(tv(j2)),' s'])
        hold on
        plot(t(i1:i2),y(i1:i2),'k','LineWidth',2)
        plot(t(i1:i2),y(i1:i2),'ok')
        pause
	end
    
    pause
	
	figure(4)
	plot(t(1:512),y(1:512),'b','LineWidth',2)
    axis([0 6 min(y) max(y)])
	grid on
	xlabel('Tempo [s]')
	ylabel('Ampiezza')
	title('Periodo fittizio in esame: 512 campioni')
	hold on
	plot(t(512:601),y(512:601),'r')
    plot([t(512) t(512)],[min(y) max(y)],'m','LineWidth',2)
	hold off
 
	pause
		
	Y = fft(y,nint);
	A = 2*abs(Y)/nint;
	A(1) = Y(1)/nint;
	F = angle(Y);

	figure(5)
	limit = nint/2;
	semilogy(f(1:limit),A(1:limit),'b','LineWidth',3)
    axis([0 f(limit) min(A) max([A k1 k2 k3])*1.2 ])
	grid on
	xlabel('Frequenza [Hz]')
	ylabel('Ampiezza componenti armoniche')
	title('Contenuto in frequenza della funzione assegnata')
    hold on
    semilogy(f(1),A(1),'ok',f1,k1,'ok',f2,k2,'ok',f3,k3,'ok')
	hold off	
	pause

	figure(6)
	plot(f(1:limit),F(1:limit)*180/pi,'b','LineWidth',3)
	axis([0 f(limit) -180 180])
	grid on
	xlabel('Frequenza [Hz]')
	ylabel('Fase componenti armoniche []')
	title('Contenuto in frequenza della funzione assegnata')
	hold on
	plot(f1,phi1*180/pi,'ok',f2,phi2*180/pi,'ok',f3,phi3*180/pi,'ok')
	hold off

	pause

% Errore di ampiezza e di fase sulle componenti

	n1 = round(1+f1*nint/fs);	
	n2 = round(1+f2*nint/fs);
	n3 = round(1+f3*nint/fs);
	n1inf = n1-4; n1sup = n1+4;
		if n1inf <= 0; n1inf=1;end
		if n1sup >= limit; n1sup=limit; end
		if n1sup <= 0; n1sup=n1inf+8;end
		if n1inf >= limit; n1inf=n1sup-8; end
	n2inf = n2-4; n2sup = n2+4;
		if n2inf <= 0; n2inf=1;end
		if n2sup >= limit; n2sup=limit; end
		if n2sup <= 0; n2sup=n2inf+8;end
		if n2inf >= limit; n2inf=n2sup-8; end
	n3inf = n3-4; n3sup = n3+4;
		if n3inf <= 0; n3inf=1;end
		if n3sup >= limit; n3sup=limit; end
		if n3sup <= 0; n3sup=n3inf+8;end
		if n3inf >= limit; n3inf=n3sup-8; end
	figure(7)

	subplot(1,3,1)
	semilogy(f(1:limit),A(1:limit),'b','LineWidth',3)
    axis([f(n1inf) f(n1sup) min([A(n1inf:n1sup) k1]) max([A(n1inf:n1sup) k1])*1.2 ])
	grid on
	ylabel('Ampiezza componenti armoniche')
    hold on
    semilogy(f(1:limit),A(1:limit),'ob',f1,k1,'rdiamond')
	hold off
	
	subplot(1,3,2)
	semilogy(f(1:limit),A(1:limit),'b','LineWidth',3)
    axis([f(n2inf) f(n2sup) min([A(n2inf:n2sup) k2]) max([A(n2inf:n2sup) k2])*1.2 ])
	grid on
	xlabel('Frequenza [Hz]')
	title('Scostamento in ampiezza delle componenti')
    hold on
    semilogy(f(1:limit),A(1:limit),'ob',f2,k2,'rdiamond')
    hold off
	
	subplot(1,3,3)
	semilogy(f(1:limit),A(1:limit),'b','LineWidth',3)
    axis([f(n3inf) f(n3sup) min([A(n3inf:n3sup) k3]) max([A(n3inf:n3sup) k3])*1.2 ])
	grid on
    hold on
    semilogy(f(1:limit),A(1:limit),'ob',f3,k3,'rdiamond')
    hold off
	
    pause

	figure(8)

	subplot(1,3,1)
	plot(f(1:limit),F(1:limit)*180/pi,'b','LineWidth',3)
    axis([f(n1inf) f(n1sup) min([F(n1inf:n1sup) phi1])*180/pi max([F(n1inf:n1sup) phi1])*180/pi ])
	grid on
	ylabel('Differenza di fase componenti armoniche []')
    hold on
	plot(f(1:limit),F(1:limit)*180/pi,'ob',f1,phi1*180/pi,'rdiamond')
    hold off
	
	
	subplot(1,3,2)
	plot(f(1:limit),F(1:limit)*180/pi,'b','LineWidth',3)
    axis([f(n2inf) f(n2sup) min([F(n2inf:n2sup) phi2])*180/pi max([F(n2inf:n2sup) phi2])*180/pi])
	grid on
	xlabel('Frequenza [Hz]')
	title('Scostamento in fase delle componenti')
    hold on
    plot(f(1:limit),F(1:limit)*180/pi,'ob',f2,phi2*180/pi,'rdiamond')
    hold off

	subplot(1,3,3)
	plot(f(1:limit),F(1:limit)*180/pi,'LineWidth',3)
    axis([f(n3inf) f(n3sup) min([F(n3inf:n3sup) phi3])*180/pi max([F(n3inf:n3sup) phi3])*180/pi])
	grid on
    hold on
    plot(f(1:limit),F(1:limit)*180/pi,'ob',f3,phi3*180/pi,'rdiamond')
	hold off
	pause

% Comparazione della curva vera con la curva ricostruita

	Z = real(ifft(Y,nint));
	limtv = t(nint)/0.002;
    
    yver = A(1);
    for j = 2:nint/2
        k = j-1;
        yver = yver + A(j)*cos(2*pi*k*t(1:nint)/t(nint+1) + F(j)); 
    end

    figure(9)
    passo = 16
        
    for i=1:32
        l1 = 16*(i-1);
        l2 = l1+passo;
        j1 = round(1+l1/fs/0.002);
        j2 = round(1+l2/fs/0.002);
        i1 = 1+l1;
        i2 = 1+l2;
        if i1 > nint
            i1 = nint;
        end
        if i2 > nint
            i2 = nint;
        end	
        plot(tv(j1:j2),yv(j1:j2),'m','LineWidth',3)
        grid on
		xlabel('Tempo [s]')
		ylabel('Ampiezza')
		title('Confronto tra funzione vera, campionata e ricostruita')        
        hold on
        plot(t(i1:i2),Z(i1:i2),'ob')
        plot(t(i1:i2),yver(i1:i2),'k','LineWidth',2)
        plot(t(i1:i2),yver(i1:i2),'*k')
		axis([l1/fs l2/fs min([y(i1:i2) yv(j1:j2)]) max([y(i1:i2) yv(j1:j2)])])		
        legend('Funzione vera','Campioni ric. IFFT','Funz. ric. armoniche')
        hold off
        pause
        
    end
    
% Comparazione della curva vera con la curva ricostruita

pause

figure(10)

subplot(2,1,1)
t1=0:0.01:10.24;
Z1 = [Z, Z, Z(1)];
plot(t1,Z1,'k','LineWidth',2)
axis([0 10.25 -10 10])
grid on
ylabel('Forma ric.')
title('Errore di periodicit')
hold on
plot([5.12 5.12],[-10 10],'m','LineWidth',2)


subplot(2,1,2)
yv =k1*cos(om1*t1+phi1) + k2*cos(om2*t1+phi2) + k3*cos(om3*t1+phi3);
plot(t1(1:1025),yv(1:1025),'b','LineWidth',2)
axis([0 10.25 -10 10])
grid on
ylabel('Forma vera')
xlabel('Tempo [s]')
hold on
plot([5.12 5.12],[-10 10],'m','LineWidth',2)
hold off

% ===================================================== %
%                                                       %
%	 	   Fine del programma			                %
%							                            %
% ===================================================== %

	
	