% ------------------------------------------------------------------------

% Function ONDAQ.M
%
% Function per la costruzione di un'onda quadra

% ------------------------------------------------------------------------


function yq = ondaq(x,amp,x1,per,xq,ver,tempo,timestep)

% ------------------------------------------------------------------------

% Variabili di scambio:
%     x = vettore dei tempi
%     amp = ampiezza dell'onda quadra
%     x1 = tempo in cui il segnale passa da basso ad alto
%     per = periodo dell'onda quadra
%     xq = tempo di permanenza del segnale al valore alto
%     tempo = tempo globale di osservazione
%     timestep = intervallo temporale di valutazione dell'onda quadra 

% ------------------------------------------------------------------------

lim = length(x);
ntime = per/timestep;
     
for j = 1:ceil(tempo/per)
    
    lim1 = 1+(j-1)*ntime;
    lim2 = lim1+(ntime-1);
    
    if lim2 >= lim
        lim2=lim;
    end
    
    xlim1 = x1+(j-1)*per;
    xlim2 = x1+xq;
    
    for i = lim1:lim2   
        yq(i) = -amp;
        if x(i) < xlim1+xlim2 & x(i) > xlim1
            yq(i) = amp;
        end
    end
        
end

yq = yq + ver;

% ------------------------------------------------------------------------
